class PgnGame {
    constructor(game, tags, moves) {
        this.game = game;
        this.tags = tags;
        this.moves = moves;
        this.currentNode = null;
    }
    
    get startPosition() {
        if(this.tags["FEN"]) {
            return this.tags["FEN"];
        }
        return "rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR w KQkq - 0 1";
    }
    
    getGame() {
        return this.game;
    }
    
    getTags() {
        return this.tags;
    }
    
    getMoves() {
        return this.moves;
    }
    
    playedMove(movearr) {
        var u = movearr.uci;
        this.game.move({
		from: u[0] + u[1],
		to: u[2] + u[3],
		promotion: u.length > 4 ? u[4] : ''
	});
        if(!this.currentNode) {
            var ix = this.moves.length;
            this.moves[ix] = movearr;
            this.currentNode = this.moves[ix];
            return;
        }
        var ix = this.currentNode.moves.length;
        this.currentNode.moves[ix] = movearr;
        this.currentNode = this.currentNode.moves[ix];
    }
    
    gotoTreeNumber(treenumber) {
 	this.game.load(this.startPosition);
        if(treenumber == '0') {
            this.currentNode = null;
            return;
        }
        var ixs = treenumber.split(".");
        this.currentNode = this.moves[ixs[1]];
        var u = this.currentNode.uci;
        this.game.move({
		from: u[0] + u[1],
		to: u[2] + u[3],
		promotion: u.length > 4 ? u[4] : ''
	});
        for(var i = 2; i < ixs.length; i++) {
            this.currentNode = this.currentNode.moves[ixs[i]];
            var u = this.currentNode.uci;
            this.game.move({
		from: u[0] + u[1],
		to: u[2] + u[3],
		promotion: u.length > 4 ? u[4] : ''
            });
        }   
    }
};
